package org.garret.serme;

/**
 * Exception thrown by this SerMe when something is going wrong.
 * It is runtime exception, so it has not to be listed in <code>throws</code> clause or catched
 */
public class SermeException extends RuntimeException { 
    /**
     * Constructor of exception
     * @param msg message explaining the reason of the problem
     */
    public SermeException(String msg) { 
        super(msg);
    }

    /**
     * Constructor of exception. Wrap thrown exception with SermeException
     * @param x original exception
     */
    public SermeException(Exception x) { 
        super(x.getMessage());
    }
}